' This is file libtcod-1.5.1_TJF.bi.bi
' (FreeBasic binding for libtcod 1.5.1 Toolkit)
'
' translated with help of h_2_bi.bas by
' Thomas.Freiherr@gmx.net:
'
' Licencing:
' This library binding is free software; you can redistribute it
' and/or modify it under the terms of the GNU Lesser General Public
' License as published by the Free Software Foundation; either
' version 2 of the License, or (at your option) ANY later version.
'
' This library is distributed in the hope that it will be useful,
' but WITHOUT ANY WARRANTY; without even the implied warranty of
' MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
' Lesser General Public License for more details, refer to:
' http://www.gnu.org/licenses/lgpl.html
'
' Original Licience:
/'
* libtcod 1.5.1
* Copyright (c) 2008,2009,2010 Jice & Mingos
* All rights reserved.
*
* libtcod 'The Doryen library' is a cross-platform C/C++ library for roguelike
* developers.
* Its source code is available from :
* http:
*
* Redistribution and use in source and binary forms, with or without
* modification, are permitted provided that the following conditions are met:
*     * Redistributions of source code must retain the above copyright
*       notice, this list of conditions and the following disclaimer.
*     * Redistributions in binary form must reproduce the above copyright
*       notice, this list of conditions and the following disclaimer in the
*       documentation and/or other materials provided with the distribution.
*     * The name of Jice or Mingos may not be used to endorse or promote products
*       derived from this software without specific prior written permission.
*
* THIS SOFTWARE IS PROVIDED BY JICE AND MINGOS ``AS IS'' AND ANY
* EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
* WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
* DISCLAIMED. IN NO EVENT SHALL JICE OR MINGOS BE LIABLE FOR ANY
* DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
* LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
* ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
* (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
* SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
'/

#IF NOT __FB_MIN_VERSION__(0, 20, 0)
  #ERROR fbc must be at least version 0.20.0 to compile this header
#ENDIF

#IFNDEF __TCOD_TJF__
#DEFINE __TCOD_TJF__

#IFDEF __FB_WIN32__
 #PRAGMA push(msbitfields)
 #INCLIB "tcod-mingw"
 #INCLIB "tcod-gui-mingw"
 #DEFINE TCOD_WINDOWS
 #DEFINE TCOD_MINGW32
 #DEFINE TCOD_WIN32
#ELSEIF NOT DEFINED(__FB_LINUX__)
 #ERROR "Platform not supported!"
#ELSE ' __FB_WIN32__
 #INCLIB "tcod"
 #DEFINE TCOD_LINUX
#ENDIF ' __FB_WIN32__

#IFDEF __TCOD_OLD_1_5_1__
 #DEFINE TCOD_console_set_default_foreground TCOD_console_set_foreground_color
 #DEFINE TCOD_console_set_default_background TCOD_console_set_background_color
 #DEFINE TCOD_console_get_default_background TCOD_console_get_background_color
 #DEFINE TCOD_console_get_default_foreground TCOD_console_get_foreground_color
 #DEFINE TCOD_console_set_char_background TCOD_console_set_back
 #DEFINE TCOD_console_set_char_foreground TCOD_console_set_fore
 #DEFINE TCOD_console_get_char_background TCOD_console_get_back
 #DEFINE TCOD_console_get_char_foreground TCOD_console_get_fore
#ENDIF ' __TCOD_OLD_1_5_1__

#LANG "fb"
EXTERN "C" ' (h_2_bi -P_oCD option)

#IFNDEF _TCODLIB_H
#DEFINE _TCODLIB_H

#IFNDEF NO_UNICODE
#INCLUDE ONCE "crt/wchar.bi" '__HEADERS__: wchar.h
#ENDIF ' NO_UNICODE

#IFDEF TCOD_MACOSX
#DEFINE _SDL_main_h
#INCLUDE ONCE "SDL/SDL.bi" '__HEADERS__: SDL/SDL.h
#ENDIF ' TCOD_MACOSX

TYPE uint8 AS UBYTE
TYPE int8 AS UBYTE
TYPE uint16 AS USHORT
TYPE int16 AS SHORT
TYPE uint32 AS UINTEGER
TYPE int32 AS INTEGER
TYPE intptr AS INTEGER
TYPE uintptr AS UINTEGER

#DEFINE TCOD_HEXVERSION &h010501
#DEFINE TCOD_STRVERSION !"1.5.1"
#DEFINE TCOD_TECHVERSION &h01050100

#IFNDEF bool

TYPE bool AS uint8

#DEFINE false CAST(bool, 0)
#DEFINE true CAST(bool, 1)
#ENDIF ' bool

DECLARE FUNCTION TCOD_strdup(BYVAL AS CONST ZSTRING PTR) AS ZSTRING PTR
DECLARE FUNCTION TCOD_strcasecmp(BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION TCOD_strncasecmp(BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS size_t) AS INTEGER

#IF DEFINED(TCOD_WINDOWS)

DECLARE FUNCTION strcasestr(BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR) AS ZSTRING PTR

#ENDIF ' DEFINED(TCOD_WI...

#IFDEF TCOD_LINUX
#UNDEF vsnwprintf
#DEFINE vsnwprintf vswprintf
#ENDIF ' TCOD_LINUX

#IFDEF TCOD_MACOSX
#UNDEF vsnwprintf
#DEFINE vsnwprintf vswprintf
#ENDIF ' TCOD_MACOSX

#IFDEF TCOD_WINDOWS
#UNDEF vsnwprintf
#DEFINE vsnwprintf _vsnwprintf
#ENDIF ' TCOD_WINDOWS

#DEFINE MAX(a,b) IIF((a) <(b), (b), (a))
#DEFINE MIN(a,b) IIF((a) >(b), (b), (a))
'#DEFINE ABS_(a) IIF((a) < 0, -(a), (a))
#DEFINE CLAMP(a, b, x) IIF((x) < (a) , (a) , IIF((x) > (b) , (b) , (x)))
#DEFINE LERP(a, b, x) ( a + x * (b - a) )

#IFNDEF _TCOD_LIST_H
#DEFINE _TCOD_LIST_H

TYPE TCOD_list_t AS ANY PTR

DECLARE FUNCTION TCOD_list_new() AS TCOD_list_t
DECLARE FUNCTION TCOD_list_allocate(BYVAL AS INTEGER) AS TCOD_list_t
DECLARE FUNCTION TCOD_list_duplicate(BYVAL AS TCOD_list_t) AS TCOD_list_t
DECLARE SUB TCOD_list_delete(BYVAL AS TCOD_list_t)
DECLARE SUB TCOD_list_push(BYVAL AS TCOD_list_t, BYVAL AS CONST ANY PTR)
DECLARE FUNCTION TCOD_list_pop(BYVAL AS TCOD_list_t) AS ANY PTR
DECLARE FUNCTION TCOD_list_peek(BYVAL AS TCOD_list_t) AS ANY PTR
DECLARE SUB TCOD_list_add_all(BYVAL AS TCOD_list_t, BYVAL AS TCOD_list_t)
DECLARE FUNCTION TCOD_list_get(BYVAL AS TCOD_list_t, BYVAL AS INTEGER) AS ANY PTR
DECLARE SUB TCOD_list_set(BYVAL AS TCOD_list_t, BYVAL AS CONST ANY PTR, BYVAL AS INTEGER)
DECLARE FUNCTION TCOD_list_begin(BYVAL AS TCOD_list_t) AS ANY PTR PTR
DECLARE FUNCTION TCOD_list_end(BYVAL AS TCOD_list_t) AS ANY PTR PTR
DECLARE FUNCTION TCOD_list_remove_iterator(BYVAL AS TCOD_list_t, BYVAL AS ANY PTR PTR) AS ANY PTR PTR
DECLARE SUB TCOD_list_remove(BYVAL AS TCOD_list_t, BYVAL AS CONST ANY PTR)
DECLARE FUNCTION TCOD_list_remove_iterator_fast(BYVAL AS TCOD_list_t, BYVAL AS ANY PTR PTR) AS ANY PTR PTR
DECLARE SUB TCOD_list_remove_fast(BYVAL AS TCOD_list_t, BYVAL AS CONST ANY PTR)
DECLARE FUNCTION TCOD_list_contains(BYVAL AS TCOD_list_t, BYVAL AS CONST ANY PTR) AS bool
DECLARE SUB TCOD_list_clear(BYVAL AS TCOD_list_t)
DECLARE SUB TCOD_list_clear_and_delete(BYVAL AS TCOD_list_t)
DECLARE FUNCTION TCOD_list_size(BYVAL AS TCOD_list_t) AS INTEGER
DECLARE FUNCTION TCOD_list_insert_before(BYVAL AS TCOD_list_t, BYVAL AS CONST ANY PTR, BYVAL AS INTEGER) AS ANY PTR PTR
DECLARE FUNCTION TCOD_list_is_empty(BYVAL AS TCOD_list_t) AS bool

#ENDIF ' _TCOD_LIST_H

#IFNDEF _TCOD_COLOR_H
#DEFINE _TCOD_COLOR_H

TYPE TCOD_color_t
  AS uint8 r, g, b
END TYPE

DECLARE FUNCTION TCOD_color_RGB(BYVAL AS uint8, BYVAL AS uint8, BYVAL AS uint8) AS TCOD_color_t
DECLARE FUNCTION TCOD_color_HSV(BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE) AS TCOD_color_t
DECLARE FUNCTION TCOD_color_equals(BYVAL AS TCOD_color_t, BYVAL AS TCOD_color_t) AS bool
DECLARE FUNCTION TCOD_color_add(BYVAL AS TCOD_color_t, BYVAL AS TCOD_color_t) AS TCOD_color_t
DECLARE FUNCTION TCOD_color_subtract(BYVAL AS TCOD_color_t, BYVAL AS TCOD_color_t) AS TCOD_color_t
DECLARE FUNCTION TCOD_color_multiply(BYVAL AS TCOD_color_t, BYVAL AS TCOD_color_t) AS TCOD_color_t
DECLARE FUNCTION TCOD_color_multiply_scalar(BYVAL AS TCOD_color_t, BYVAL AS SINGLE) AS TCOD_color_t
DECLARE FUNCTION TCOD_color_lerp(BYVAL AS TCOD_color_t, BYVAL AS TCOD_color_t, BYVAL AS SINGLE) AS TCOD_color_t
DECLARE SUB TCOD_color_set_HSV(BYVAL AS TCOD_color_t PTR, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_color_get_HSV(BYVAL AS TCOD_color_t, BYVAL AS SINGLE PTR, BYVAL AS SINGLE PTR, BYVAL AS SINGLE PTR)
DECLARE FUNCTION TCOD_color_get_hue(BYVAL AS TCOD_color_t) AS SINGLE
DECLARE SUB TCOD_color_set_hue(BYVAL AS TCOD_color_t PTR, BYVAL AS SINGLE)
DECLARE FUNCTION TCOD_color_get_saturation(BYVAL AS TCOD_color_t) AS SINGLE
DECLARE SUB TCOD_color_set_saturation(BYVAL AS TCOD_color_t PTR, BYVAL AS SINGLE)
DECLARE FUNCTION TCOD_color_get_value(BYVAL AS TCOD_color_t) AS SINGLE
DECLARE SUB TCOD_color_set_value(BYVAL AS TCOD_color_t PTR, BYVAL AS SINGLE)
DECLARE SUB TCOD_color_shift_hue(BYVAL AS TCOD_color_t PTR, BYVAL AS SINGLE)
DECLARE SUB TCOD_color_scale_HSV(BYVAL AS TCOD_color_t PTR, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_color_gen_map(BYVAL AS TCOD_color_t PTR, BYVAL AS INTEGER, BYVAL AS TCOD_color_t CONST PTR, BYVAL AS INTEGER CONST PTR)

ENUM
  TCOD_COLOR_RED
  TCOD_COLOR_FLAME
  TCOD_COLOR_ORANGE
  TCOD_COLOR_AMBER
  TCOD_COLOR_YELLOW
  TCOD_COLOR_LIME
  TCOD_COLOR_CHARTREUSE
  TCOD_COLOR_GREEN
  TCOD_COLOR_SEA
  TCOD_COLOR_TURQUOISE
  TCOD_COLOR_CYAN
  TCOD_COLOR_SKY
  TCOD_COLOR_AZURE
  TCOD_COLOR_BLUE
  TCOD_COLOR_HAN
  TCOD_COLOR_VIOLET
  TCOD_COLOR_PURPLE
  TCOD_COLOR_FUCHSIA
  TCOD_COLOR_MAGENTA
  TCOD_COLOR_PINK
  TCOD_COLOR_CRIMSON
  TCOD_COLOR_NB
END ENUM

ENUM
  TCOD_COLOR_DESATURATED
  TCOD_COLOR_LIGHTEST
  TCOD_COLOR_LIGHTER
  TCOD_COLOR_LIGHT
  TCOD_COLOR_NORMAL
  TCOD_COLOR_DARK
  TCOD_COLOR_DARKER
  TCOD_COLOR_DARKEST
  TCOD_COLOR_LEVELS
END ENUM

EXTERN AS CONST TCOD_color_t TCOD_colors(TCOD_COLOR_NB-1, TCOD_COLOR_LEVELS-1)
EXTERN AS CONST TCOD_color_t TCOD_black
EXTERN AS CONST TCOD_color_t TCOD_darkest_grey
EXTERN AS CONST TCOD_color_t TCOD_darker_grey
EXTERN AS CONST TCOD_color_t TCOD_dark_grey
EXTERN AS CONST TCOD_color_t TCOD_grey
EXTERN AS CONST TCOD_color_t TCOD_light_grey
EXTERN AS CONST TCOD_color_t TCOD_lighter_grey
EXTERN AS CONST TCOD_color_t TCOD_lightest_grey
EXTERN AS CONST TCOD_color_t TCOD_darkest_gray
EXTERN AS CONST TCOD_color_t TCOD_darker_gray
EXTERN AS CONST TCOD_color_t TCOD_dark_gray
EXTERN AS CONST TCOD_color_t TCOD_gray
EXTERN AS CONST TCOD_color_t TCOD_light_gray
EXTERN AS CONST TCOD_color_t TCOD_lighter_gray
EXTERN AS CONST TCOD_color_t TCOD_lightest_gray
EXTERN AS CONST TCOD_color_t TCOD_white
EXTERN AS CONST TCOD_color_t TCOD_darkest_sepia
EXTERN AS CONST TCOD_color_t TCOD_darker_sepia
EXTERN AS CONST TCOD_color_t TCOD_dark_sepia
EXTERN AS CONST TCOD_color_t TCOD_sepia
EXTERN AS CONST TCOD_color_t TCOD_light_sepia
EXTERN AS CONST TCOD_color_t TCOD_lighter_sepia
EXTERN AS CONST TCOD_color_t TCOD_lightest_sepia
EXTERN AS CONST TCOD_color_t TCOD_red
EXTERN AS CONST TCOD_color_t TCOD_flame
EXTERN AS CONST TCOD_color_t TCOD_orange
EXTERN AS CONST TCOD_color_t TCOD_amber
EXTERN AS CONST TCOD_color_t TCOD_yellow
EXTERN AS CONST TCOD_color_t TCOD_lime
EXTERN AS CONST TCOD_color_t TCOD_chartreuse
EXTERN AS CONST TCOD_color_t TCOD_green
EXTERN AS CONST TCOD_color_t TCOD_sea
EXTERN AS CONST TCOD_color_t TCOD_turquoise
EXTERN AS CONST TCOD_color_t TCOD_cyan
EXTERN AS CONST TCOD_color_t TCOD_sky
EXTERN AS CONST TCOD_color_t TCOD_azure
EXTERN AS CONST TCOD_color_t TCOD_blue
EXTERN AS CONST TCOD_color_t TCOD_han
EXTERN AS CONST TCOD_color_t TCOD_violet
EXTERN AS CONST TCOD_color_t TCOD_purple
EXTERN AS CONST TCOD_color_t TCOD_fuchsia
EXTERN AS CONST TCOD_color_t TCOD_magenta
EXTERN AS CONST TCOD_color_t TCOD_pink
EXTERN AS CONST TCOD_color_t TCOD_crimson
EXTERN AS CONST TCOD_color_t TCOD_dark_red
EXTERN AS CONST TCOD_color_t TCOD_dark_flame
EXTERN AS CONST TCOD_color_t TCOD_dark_orange
EXTERN AS CONST TCOD_color_t TCOD_dark_amber
EXTERN AS CONST TCOD_color_t TCOD_dark_yellow
EXTERN AS CONST TCOD_color_t TCOD_dark_lime
EXTERN AS CONST TCOD_color_t TCOD_dark_chartreuse
EXTERN AS CONST TCOD_color_t TCOD_dark_green
EXTERN AS CONST TCOD_color_t TCOD_dark_sea
EXTERN AS CONST TCOD_color_t TCOD_dark_turquoise
EXTERN AS CONST TCOD_color_t TCOD_dark_cyan
EXTERN AS CONST TCOD_color_t TCOD_dark_sky
EXTERN AS CONST TCOD_color_t TCOD_dark_azure
EXTERN AS CONST TCOD_color_t TCOD_dark_blue
EXTERN AS CONST TCOD_color_t TCOD_dark_han
EXTERN AS CONST TCOD_color_t TCOD_dark_violet
EXTERN AS CONST TCOD_color_t TCOD_dark_purple
EXTERN AS CONST TCOD_color_t TCOD_dark_fuchsia
EXTERN AS CONST TCOD_color_t TCOD_dark_magenta
EXTERN AS CONST TCOD_color_t TCOD_dark_pink
EXTERN AS CONST TCOD_color_t TCOD_dark_crimson
EXTERN AS CONST TCOD_color_t TCOD_darker_red
EXTERN AS CONST TCOD_color_t TCOD_darker_flame
EXTERN AS CONST TCOD_color_t TCOD_darker_orange
EXTERN AS CONST TCOD_color_t TCOD_darker_amber
EXTERN AS CONST TCOD_color_t TCOD_darker_yellow
EXTERN AS CONST TCOD_color_t TCOD_darker_lime
EXTERN AS CONST TCOD_color_t TCOD_darker_chartreuse
EXTERN AS CONST TCOD_color_t TCOD_darker_green
EXTERN AS CONST TCOD_color_t TCOD_darker_sea
EXTERN AS CONST TCOD_color_t TCOD_darker_turquoise
EXTERN AS CONST TCOD_color_t TCOD_darker_cyan
EXTERN AS CONST TCOD_color_t TCOD_darker_sky
EXTERN AS CONST TCOD_color_t TCOD_darker_azure
EXTERN AS CONST TCOD_color_t TCOD_darker_blue
EXTERN AS CONST TCOD_color_t TCOD_darker_han
EXTERN AS CONST TCOD_color_t TCOD_darker_violet
EXTERN AS CONST TCOD_color_t TCOD_darker_purple
EXTERN AS CONST TCOD_color_t TCOD_darker_fuchsia
EXTERN AS CONST TCOD_color_t TCOD_darker_magenta
EXTERN AS CONST TCOD_color_t TCOD_darker_pink
EXTERN AS CONST TCOD_color_t TCOD_darker_crimson
EXTERN AS CONST TCOD_color_t TCOD_darkest_red
EXTERN AS CONST TCOD_color_t TCOD_darkest_flame
EXTERN AS CONST TCOD_color_t TCOD_darkest_orange
EXTERN AS CONST TCOD_color_t TCOD_darkest_amber
EXTERN AS CONST TCOD_color_t TCOD_darkest_yellow
EXTERN AS CONST TCOD_color_t TCOD_darkest_lime
EXTERN AS CONST TCOD_color_t TCOD_darkest_chartreuse
EXTERN AS CONST TCOD_color_t TCOD_darkest_green
EXTERN AS CONST TCOD_color_t TCOD_darkest_sea
EXTERN AS CONST TCOD_color_t TCOD_darkest_turquoise
EXTERN AS CONST TCOD_color_t TCOD_darkest_cyan
EXTERN AS CONST TCOD_color_t TCOD_darkest_sky
EXTERN AS CONST TCOD_color_t TCOD_darkest_azure
EXTERN AS CONST TCOD_color_t TCOD_darkest_blue
EXTERN AS CONST TCOD_color_t TCOD_darkest_han
EXTERN AS CONST TCOD_color_t TCOD_darkest_violet
EXTERN AS CONST TCOD_color_t TCOD_darkest_purple
EXTERN AS CONST TCOD_color_t TCOD_darkest_fuchsia
EXTERN AS CONST TCOD_color_t TCOD_darkest_magenta
EXTERN AS CONST TCOD_color_t TCOD_darkest_pink
EXTERN AS CONST TCOD_color_t TCOD_darkest_crimson
EXTERN AS CONST TCOD_color_t TCOD_light_red
EXTERN AS CONST TCOD_color_t TCOD_light_flame
EXTERN AS CONST TCOD_color_t TCOD_light_orange
EXTERN AS CONST TCOD_color_t TCOD_light_amber
EXTERN AS CONST TCOD_color_t TCOD_light_yellow
EXTERN AS CONST TCOD_color_t TCOD_light_lime
EXTERN AS CONST TCOD_color_t TCOD_light_chartreuse
EXTERN AS CONST TCOD_color_t TCOD_light_green
EXTERN AS CONST TCOD_color_t TCOD_light_sea
EXTERN AS CONST TCOD_color_t TCOD_light_turquoise
EXTERN AS CONST TCOD_color_t TCOD_light_cyan
EXTERN AS CONST TCOD_color_t TCOD_light_sky
EXTERN AS CONST TCOD_color_t TCOD_light_azure
EXTERN AS CONST TCOD_color_t TCOD_light_blue
EXTERN AS CONST TCOD_color_t TCOD_light_han
EXTERN AS CONST TCOD_color_t TCOD_light_violet
EXTERN AS CONST TCOD_color_t TCOD_light_purple
EXTERN AS CONST TCOD_color_t TCOD_light_fuchsia
EXTERN AS CONST TCOD_color_t TCOD_light_magenta
EXTERN AS CONST TCOD_color_t TCOD_light_pink
EXTERN AS CONST TCOD_color_t TCOD_light_crimson
EXTERN AS CONST TCOD_color_t TCOD_lighter_red
EXTERN AS CONST TCOD_color_t TCOD_lighter_flame
EXTERN AS CONST TCOD_color_t TCOD_lighter_orange
EXTERN AS CONST TCOD_color_t TCOD_lighter_amber
EXTERN AS CONST TCOD_color_t TCOD_lighter_yellow
EXTERN AS CONST TCOD_color_t TCOD_lighter_lime
EXTERN AS CONST TCOD_color_t TCOD_lighter_chartreuse
EXTERN AS CONST TCOD_color_t TCOD_lighter_green
EXTERN AS CONST TCOD_color_t TCOD_lighter_sea
EXTERN AS CONST TCOD_color_t TCOD_lighter_turquoise
EXTERN AS CONST TCOD_color_t TCOD_lighter_cyan
EXTERN AS CONST TCOD_color_t TCOD_lighter_sky
EXTERN AS CONST TCOD_color_t TCOD_lighter_azure
EXTERN AS CONST TCOD_color_t TCOD_lighter_blue
EXTERN AS CONST TCOD_color_t TCOD_lighter_han
EXTERN AS CONST TCOD_color_t TCOD_lighter_violet
EXTERN AS CONST TCOD_color_t TCOD_lighter_purple
EXTERN AS CONST TCOD_color_t TCOD_lighter_fuchsia
EXTERN AS CONST TCOD_color_t TCOD_lighter_magenta
EXTERN AS CONST TCOD_color_t TCOD_lighter_pink
EXTERN AS CONST TCOD_color_t TCOD_lighter_crimson
EXTERN AS CONST TCOD_color_t TCOD_lightest_red
EXTERN AS CONST TCOD_color_t TCOD_lightest_flame
EXTERN AS CONST TCOD_color_t TCOD_lightest_orange
EXTERN AS CONST TCOD_color_t TCOD_lightest_amber
EXTERN AS CONST TCOD_color_t TCOD_lightest_yellow
EXTERN AS CONST TCOD_color_t TCOD_lightest_lime
EXTERN AS CONST TCOD_color_t TCOD_lightest_chartreuse
EXTERN AS CONST TCOD_color_t TCOD_lightest_green
EXTERN AS CONST TCOD_color_t TCOD_lightest_sea
EXTERN AS CONST TCOD_color_t TCOD_lightest_turquoise
EXTERN AS CONST TCOD_color_t TCOD_lightest_cyan
EXTERN AS CONST TCOD_color_t TCOD_lightest_sky
EXTERN AS CONST TCOD_color_t TCOD_lightest_azure
EXTERN AS CONST TCOD_color_t TCOD_lightest_blue
EXTERN AS CONST TCOD_color_t TCOD_lightest_han
EXTERN AS CONST TCOD_color_t TCOD_lightest_violet
EXTERN AS CONST TCOD_color_t TCOD_lightest_purple
EXTERN AS CONST TCOD_color_t TCOD_lightest_fuchsia
EXTERN AS CONST TCOD_color_t TCOD_lightest_magenta
EXTERN AS CONST TCOD_color_t TCOD_lightest_pink
EXTERN AS CONST TCOD_color_t TCOD_lightest_crimson
EXTERN AS CONST TCOD_color_t TCOD_desaturated_red
EXTERN AS CONST TCOD_color_t TCOD_desaturated_flame
EXTERN AS CONST TCOD_color_t TCOD_desaturated_orange
EXTERN AS CONST TCOD_color_t TCOD_desaturated_amber
EXTERN AS CONST TCOD_color_t TCOD_desaturated_yellow
EXTERN AS CONST TCOD_color_t TCOD_desaturated_lime
EXTERN AS CONST TCOD_color_t TCOD_desaturated_chartreuse
EXTERN AS CONST TCOD_color_t TCOD_desaturated_green
EXTERN AS CONST TCOD_color_t TCOD_desaturated_sea
EXTERN AS CONST TCOD_color_t TCOD_desaturated_turquoise
EXTERN AS CONST TCOD_color_t TCOD_desaturated_cyan
EXTERN AS CONST TCOD_color_t TCOD_desaturated_sky
EXTERN AS CONST TCOD_color_t TCOD_desaturated_azure
EXTERN AS CONST TCOD_color_t TCOD_desaturated_blue
EXTERN AS CONST TCOD_color_t TCOD_desaturated_han
EXTERN AS CONST TCOD_color_t TCOD_desaturated_violet
EXTERN AS CONST TCOD_color_t TCOD_desaturated_purple
EXTERN AS CONST TCOD_color_t TCOD_desaturated_fuchsia
EXTERN AS CONST TCOD_color_t TCOD_desaturated_magenta
EXTERN AS CONST TCOD_color_t TCOD_desaturated_pink
EXTERN AS CONST TCOD_color_t TCOD_desaturated_crimson
EXTERN AS CONST TCOD_color_t TCOD_brass
EXTERN AS CONST TCOD_color_t TCOD_copper
EXTERN AS CONST TCOD_color_t TCOD_gold
EXTERN AS CONST TCOD_color_t TCOD_silver
EXTERN AS CONST TCOD_color_t TCOD_celadon
EXTERN AS CONST TCOD_color_t TCOD_peach

#ENDIF ' _TCOD_COLOR_H

#IFNDEF _TCOD_CONSOLE_H
#DEFINE _TCOD_CONSOLE_H

#IFNDEF _TCOD_CONSOLE_TYPES_H
#DEFINE _TCOD_CONSOLE_TYPES_H

ENUM TCOD_keycode_t
  TCODK_NONE
  TCODK_ESCAPE
  TCODK_BACKSPACE
  TCODK_TAB
  TCODK_ENTER
  TCODK_SHIFT
  TCODK_CONTROL
  TCODK_ALT
  TCODK_PAUSE
  TCODK_CAPSLOCK
  TCODK_PAGEUP
  TCODK_PAGEDOWN
  TCODK_END
  TCODK_HOME
  TCODK_UP
  TCODK_LEFT
  TCODK_RIGHT
  TCODK_DOWN
  TCODK_PRINTSCREEN
  TCODK_INSERT
  TCODK_DELETE
  TCODK_LWIN
  TCODK_RWIN
  TCODK_APPS
  TCODK_0
  TCODK_1
  TCODK_2
  TCODK_3
  TCODK_4
  TCODK_5
  TCODK_6
  TCODK_7
  TCODK_8
  TCODK_9
  TCODK_KP0
  TCODK_KP1
  TCODK_KP2
  TCODK_KP3
  TCODK_KP4
  TCODK_KP5
  TCODK_KP6
  TCODK_KP7
  TCODK_KP8
  TCODK_KP9
  TCODK_KPADD
  TCODK_KPSUB
  TCODK_KPDIV
  TCODK_KPMUL
  TCODK_KPDEC
  TCODK_KPENTER
  TCODK_F1
  TCODK_F2
  TCODK_F3
  TCODK_F4
  TCODK_F5
  TCODK_F6
  TCODK_F7
  TCODK_F8
  TCODK_F9
  TCODK_F10
  TCODK_F11
  TCODK_F12
  TCODK_NUMLOCK
  TCODK_SCROLLLOCK
  TCODK_SPACE
  TCODK_CHAR
END ENUM

TYPE TCOD_key_t
  AS TCOD_keycode_t vk
  AS UBYTE c
  AS bool pressed
  AS bool lalt
  AS bool lctrl
  AS bool ralt
  AS bool rctrl
  AS bool shift
END TYPE

ENUM TCOD_chars_t
  TCOD_CHAR_HLINE = 196
  TCOD_CHAR_VLINE = 179
  TCOD_CHAR_NE = 191
  TCOD_CHAR_NW = 218
  TCOD_CHAR_SE = 217
  TCOD_CHAR_SW = 192
  TCOD_CHAR_TEEW = 180
  TCOD_CHAR_TEEE = 195
  TCOD_CHAR_TEEN = 193
  TCOD_CHAR_TEES = 194
  TCOD_CHAR_CROSS = 197
  TCOD_CHAR_DHLINE = 205
  TCOD_CHAR_DVLINE = 186
  TCOD_CHAR_DNE = 187
  TCOD_CHAR_DNW = 201
  TCOD_CHAR_DSE = 188
  TCOD_CHAR_DSW = 200
  TCOD_CHAR_DTEEW = 185
  TCOD_CHAR_DTEEE = 204
  TCOD_CHAR_DTEEN = 202
  TCOD_CHAR_DTEES = 203
  TCOD_CHAR_DCROSS = 206
  TCOD_CHAR_BLOCK1 = 176
  TCOD_CHAR_BLOCK2 = 177
  TCOD_CHAR_BLOCK3 = 178
  TCOD_CHAR_ARROW_N = 24
  TCOD_CHAR_ARROW_S = 25
  TCOD_CHAR_ARROW_E = 26
  TCOD_CHAR_ARROW_W = 27
  TCOD_CHAR_ARROW2_N = 30
  TCOD_CHAR_ARROW2_S = 31
  TCOD_CHAR_ARROW2_E = 16
  TCOD_CHAR_ARROW2_W = 17
  TCOD_CHAR_DARROW_H = 29
  TCOD_CHAR_DARROW_V = 18
  TCOD_CHAR_CHECKBOX_UNSET = 224
  TCOD_CHAR_CHECKBOX_SET = 225
  TCOD_CHAR_RADIO_UNSET = 9
  TCOD_CHAR_RADIO_SET = 10
  TCOD_CHAR_SUBP_NW = 226
  TCOD_CHAR_SUBP_NE = 227
  TCOD_CHAR_SUBP_N = 228
  TCOD_CHAR_SUBP_SE = 229
  TCOD_CHAR_SUBP_DIAG = 230
  TCOD_CHAR_SUBP_E = 231
  TCOD_CHAR_SUBP_SW = 232
  TCOD_CHAR_SMILIE = 1
  TCOD_CHAR_SMILIE_INV = 2
  TCOD_CHAR_HEART = 3
  TCOD_CHAR_DIAMOND = 4
  TCOD_CHAR_CLUB = 5
  TCOD_CHAR_SPADE = 6
  TCOD_CHAR_BULLET = 7
  TCOD_CHAR_BULLET_INV = 8
  TCOD_CHAR_MALE = 11
  TCOD_CHAR_FEMALE = 12
  TCOD_CHAR_NOTE = 13
  TCOD_CHAR_NOTE_DOUBLE = 14
  TCOD_CHAR_LIGHT = 15
  TCOD_CHAR_EXCLAM_DOUBLE = 19
  TCOD_CHAR_PILCROW = 20
  TCOD_CHAR_SECTION = 21
  TCOD_CHAR_POUND = 156
  TCOD_CHAR_MULTIPLICATION = 158
  TCOD_CHAR_FUNCTION = 159
  TCOD_CHAR_RESERVED = 169
  TCOD_CHAR_HALF = 171
  TCOD_CHAR_ONE_QUARTER = 172
  TCOD_CHAR_COPYRIGHT = 184
  TCOD_CHAR_CENT = 189
  TCOD_CHAR_YEN = 190
  TCOD_CHAR_CURRENCY = 207
  TCOD_CHAR_THREE_QUARTERS = 243
  TCOD_CHAR_DIVISION = 246
  TCOD_CHAR_GRADE = 248
  TCOD_CHAR_UMLAUT = 249
  TCOD_CHAR_POW1 = 251
  TCOD_CHAR_POW3 = 252
  TCOD_CHAR_POW2 = 253
  TCOD_CHAR_BULLET_SQUARE = 254
END ENUM

ENUM TCOD_colctrl_t
  TCOD_COLCTRL_1 = 1
  TCOD_COLCTRL_2
  TCOD_COLCTRL_3
  TCOD_COLCTRL_4
  TCOD_COLCTRL_5
  TCOD_COLCTRL_NUMBER = 5
  TCOD_COLCTRL_FORE_RGB
  TCOD_COLCTRL_BACK_RGB
  TCOD_COLCTRL_STOP
END ENUM

ENUM TCOD_bkgnd_flag_t
  TCOD_BKGND_NONE
  TCOD_BKGND_SET
  TCOD_BKGND_MULTIPLY
  TCOD_BKGND_LIGHTEN
  TCOD_BKGND_DARKEN
  TCOD_BKGND_SCREEN
  TCOD_BKGND_COLOR_DODGE
  TCOD_BKGND_COLOR_BURN
  TCOD_BKGND_ADD
  TCOD_BKGND_ADDA
  TCOD_BKGND_BURN
  TCOD_BKGND_OVERLAY
  TCOD_BKGND_ALPH
  TCOD_BKGND_DEFAULT
END ENUM

ENUM TCOD_key_status_t
  TCOD_KEY_PRESSED = 1
  TCOD_KEY_RELEASED = 2
END ENUM

ENUM TCOD_font_flags_t
  TCOD_FONT_LAYOUT_ASCII_INCOL = 1
  TCOD_FONT_LAYOUT_ASCII_INROW = 2
  TCOD_FONT_TYPE_GREYSCALE = 4
  TCOD_FONT_TYPE_GRAYSCALE = 4
  TCOD_FONT_LAYOUT_TCOD = 8
END ENUM

ENUM TCOD_renderer_t
  TCOD_RENDERER_GLSL
  TCOD_RENDERER_OPENGL
  TCOD_RENDERER_SDL
  TCOD_NB_RENDERERS
END ENUM

ENUM TCOD_alignment_t
  TCOD_LEFT
  TCOD_RIGHT
  TCOD_CENTER
END ENUM

#ENDIF ' _TCOD_CONSOLE_TYPES_H

#DEFINE TCOD_BKGND_ALPHA(alpha) ((TCOD_bkgnd_flag_t)(TCOD_BKGND_ALPH OR(((uint8)(alpha*255)) SHL 8)))
#DEFINE TCOD_BKGND_ADDALPHA(alpha) ((TCOD_bkgnd_flag_t)(TCOD_BKGND_ADDA OR(((uint8)(alpha*255)) SHL 8)))

TYPE TCOD_console_t AS ANY PTR

DECLARE SUB TCOD_console_init_root(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, BYVAL AS bool, BYVAL AS TCOD_renderer_t)
DECLARE SUB TCOD_console_set_window_title(BYVAL AS CONST ZSTRING PTR)
DECLARE SUB TCOD_console_set_fullscreen(BYVAL AS bool)
DECLARE FUNCTION TCOD_console_is_fullscreen() AS bool
DECLARE FUNCTION TCOD_console_is_window_closed() AS bool
DECLARE SUB TCOD_console_set_custom_font(BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_console_map_ascii_code_to_font(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_console_map_ascii_codes_to_font(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_console_map_string_to_font(BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_console_set_dirty(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_console_set_default_background(BYVAL AS TCOD_console_t, BYVAL AS TCOD_color_t)
DECLARE SUB TCOD_console_set_default_foreground(BYVAL AS TCOD_console_t, BYVAL AS TCOD_color_t)
DECLARE SUB TCOD_console_clear(BYVAL AS TCOD_console_t)
DECLARE SUB TCOD_console_set_char_background(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_color_t, BYVAL AS TCOD_bkgnd_flag_t)
DECLARE SUB TCOD_console_set_char_foreground(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_color_t)
DECLARE SUB TCOD_console_set_char(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_console_put_char(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_bkgnd_flag_t)
DECLARE SUB TCOD_console_put_char_ex(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_color_t, BYVAL AS TCOD_color_t)
DECLARE SUB TCOD_console_set_background_flag(BYVAL AS TCOD_console_t, BYVAL AS TCOD_bkgnd_flag_t)
DECLARE FUNCTION TCOD_console_get_background_flag(BYVAL AS TCOD_console_t) AS TCOD_bkgnd_flag_t
DECLARE SUB TCOD_console_set_alignment(BYVAL AS TCOD_console_t, BYVAL AS TCOD_alignment_t)
DECLARE FUNCTION TCOD_console_get_alignment(BYVAL AS TCOD_console_t) AS TCOD_alignment_t
DECLARE SUB TCOD_console_print(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, ...)
DECLARE SUB TCOD_console_print_ex(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_bkgnd_flag_t, BYVAL AS TCOD_alignment_t, BYVAL AS CONST ZSTRING PTR, ...)
DECLARE FUNCTION TCOD_console_print_rect(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, ...) AS INTEGER
DECLARE FUNCTION TCOD_console_print_rect_ex(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_bkgnd_flag_t, BYVAL AS TCOD_alignment_t, BYVAL AS CONST ZSTRING PTR, ...) AS INTEGER
DECLARE FUNCTION TCOD_console_get_height_rect(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, ...) AS INTEGER
DECLARE SUB TCOD_console_rect(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS bool, BYVAL AS TCOD_bkgnd_flag_t)
DECLARE SUB TCOD_console_hline(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_bkgnd_flag_t)
DECLARE SUB TCOD_console_vline(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_bkgnd_flag_t)
DECLARE SUB TCOD_console_print_frame(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS bool, BYVAL AS TCOD_bkgnd_flag_t, BYVAL AS CONST ZSTRING PTR, ...)

#IFNDEF NO_UNICODE

DECLARE SUB TCOD_console_map_string_to_font_utf(BYVAL AS CONST wchar_t PTR, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_console_print_utf(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST wchar_t PTR, ...)
DECLARE SUB TCOD_console_print_ex_utf(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_bkgnd_flag_t, BYVAL AS TCOD_alignment_t, BYVAL AS CONST wchar_t PTR, ...)
DECLARE FUNCTION TCOD_console_print_rect_utf(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST wchar_t PTR, ...) AS INTEGER
DECLARE FUNCTION TCOD_console_print_rect_ex_utf(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_bkgnd_flag_t, BYVAL AS TCOD_alignment_t, BYVAL AS CONST wchar_t PTR, ...) AS INTEGER
DECLARE FUNCTION TCOD_console_get_height_rect_utf(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST wchar_t PTR, ...) AS INTEGER

#ENDIF ' NO_UNICODE

DECLARE FUNCTION TCOD_console_get_default_background(BYVAL AS TCOD_console_t) AS TCOD_color_t
DECLARE FUNCTION TCOD_console_get_default_foreground(BYVAL AS TCOD_console_t) AS TCOD_color_t
DECLARE FUNCTION TCOD_console_get_back(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS TCOD_color_t
DECLARE FUNCTION TCOD_console_get_fore(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS TCOD_color_t
DECLARE FUNCTION TCOD_console_get_char(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER
DECLARE SUB TCOD_console_set_fade(BYVAL AS uint8, BYVAL AS TCOD_color_t)
DECLARE FUNCTION TCOD_console_get_fade() AS uint8
DECLARE FUNCTION TCOD_console_get_fading_color() AS TCOD_color_t
DECLARE SUB TCOD_console_flush()
DECLARE SUB TCOD_console_set_color_control(BYVAL AS TCOD_colctrl_t, BYVAL AS TCOD_color_t, BYVAL AS TCOD_color_t)
DECLARE FUNCTION TCOD_console_check_for_keypress(BYVAL AS INTEGER) AS TCOD_key_t
DECLARE FUNCTION TCOD_console_wait_for_keypress(BYVAL AS bool) AS TCOD_key_t
DECLARE SUB TCOD_console_set_keyboard_repeat(BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_console_disable_keyboard_repeat()
DECLARE FUNCTION TCOD_console_is_key_pressed(BYVAL AS TCOD_keycode_t) AS bool
DECLARE FUNCTION TCOD_console_new(BYVAL AS INTEGER, BYVAL AS INTEGER) AS TCOD_console_t
DECLARE FUNCTION TCOD_console_get_width(BYVAL AS TCOD_console_t) AS INTEGER
DECLARE FUNCTION TCOD_console_get_height(BYVAL AS TCOD_console_t) AS INTEGER
DECLARE SUB TCOD_console_set_key_color(BYVAL AS TCOD_console_t, BYVAL AS TCOD_color_t)
DECLARE SUB TCOD_console_blit(BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_console_delete(BYVAL AS TCOD_console_t)
DECLARE SUB TCOD_console_credits()
DECLARE SUB TCOD_console_credits_reset()
DECLARE FUNCTION TCOD_console_credits_render(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS bool) AS bool

#ENDIF ' _TCOD_CONSOLE_H

TYPE TCOD_image_t AS ANY PTR

DECLARE FUNCTION TCOD_image_new(BYVAL AS INTEGER, BYVAL AS INTEGER) AS TCOD_image_t
DECLARE FUNCTION TCOD_image_from_console(BYVAL AS TCOD_console_t) AS TCOD_image_t
DECLARE SUB TCOD_image_refresh_console(BYVAL AS TCOD_image_t, BYVAL AS TCOD_console_t)
DECLARE FUNCTION TCOD_image_load(BYVAL AS CONST ZSTRING PTR) AS TCOD_image_t
DECLARE SUB TCOD_image_clear(BYVAL AS TCOD_image_t, BYVAL AS TCOD_color_t)
DECLARE SUB TCOD_image_invert(BYVAL AS TCOD_image_t)
DECLARE SUB TCOD_image_hflip(BYVAL AS TCOD_image_t)
DECLARE SUB TCOD_image_vflip(BYVAL AS TCOD_image_t)
DECLARE SUB TCOD_image_scale(BYVAL AS TCOD_image_t, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_image_save(BYVAL AS TCOD_image_t, BYVAL AS CONST ZSTRING PTR)
DECLARE SUB TCOD_image_get_size(BYVAL AS TCOD_image_t, BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR)
DECLARE FUNCTION TCOD_image_get_pixel(BYVAL AS TCOD_image_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS TCOD_color_t
DECLARE FUNCTION TCOD_image_get_alpha(BYVAL AS TCOD_image_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION TCOD_image_get_mipmap_pixel(BYVAL AS TCOD_image_t, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE) AS TCOD_color_t
DECLARE SUB TCOD_image_put_pixel(BYVAL AS TCOD_image_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_color_t)
DECLARE SUB TCOD_image_blit(BYVAL AS TCOD_image_t, BYVAL AS TCOD_console_t, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS TCOD_bkgnd_flag_t, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_image_blit_rect(BYVAL AS TCOD_image_t, BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_bkgnd_flag_t)
DECLARE SUB TCOD_image_blit_2x(BYVAL AS TCOD_image_t, BYVAL AS TCOD_console_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_image_delete(BYVAL AS TCOD_image_t)
DECLARE SUB TCOD_image_set_key_color(BYVAL AS TCOD_image_t, BYVAL AS TCOD_color_t)
DECLARE FUNCTION TCOD_image_is_pixel_transparent(BYVAL AS TCOD_image_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS bool

#IFNDEF _TCOD_SYS_H
#DEFINE _TCOD_SYS_H

DECLARE FUNCTION TCOD_sys_elapsed_milli() AS uint32
DECLARE FUNCTION TCOD_sys_elapsed_seconds() AS SINGLE
DECLARE SUB TCOD_sys_sleep_milli(BYVAL AS uint32)
DECLARE SUB TCOD_sys_save_screenshot(BYVAL AS CONST ZSTRING PTR)
DECLARE SUB TCOD_sys_force_fullscreen_resolution(BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_sys_set_renderer(BYVAL AS TCOD_renderer_t)
DECLARE FUNCTION TCOD_sys_get_renderer() AS TCOD_renderer_t
DECLARE SUB TCOD_sys_set_fps(BYVAL AS INTEGER)
DECLARE FUNCTION TCOD_sys_get_fps() AS INTEGER
DECLARE FUNCTION TCOD_sys_get_last_frame_length() AS SINGLE
DECLARE SUB TCOD_sys_get_current_resolution(BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR)
DECLARE SUB TCOD_sys_update_char(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_image_t, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_sys_get_char_size(BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR)
DECLARE FUNCTION TCOD_sys_create_directory(BYVAL AS CONST ZSTRING PTR) AS bool
DECLARE FUNCTION TCOD_sys_delete_file(BYVAL AS CONST ZSTRING PTR) AS bool
DECLARE FUNCTION TCOD_sys_delete_directory(BYVAL AS CONST ZSTRING PTR) AS bool
DECLARE FUNCTION TCOD_sys_is_directory(BYVAL AS CONST ZSTRING PTR) AS bool
DECLARE FUNCTION TCOD_sys_get_directory_content(BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR) AS TCOD_list_t
DECLARE SUB TCOD_sys_clipboard_set(BYVAL AS CONST ZSTRING PTR)
DECLARE FUNCTION TCOD_sys_clipboard_get() AS ZSTRING PTR

TYPE TCOD_thread_t AS ANY PTR
TYPE TCOD_semaphore_t AS ANY PTR
TYPE TCOD_mutex_t AS ANY PTR
TYPE TCOD_cond_t AS ANY PTR

DECLARE FUNCTION TCOD_thread_new(BYVAL AS FUNCTION(BYVAL AS ANY PTR) AS INTEGER, BYVAL AS ANY PTR) AS TCOD_thread_t
DECLARE SUB TCOD_thread_delete(BYVAL AS TCOD_thread_t)
DECLARE FUNCTION TCOD_sys_get_num_cores() AS INTEGER
DECLARE SUB TCOD_thread_wait(BYVAL AS TCOD_thread_t)
DECLARE FUNCTION TCOD_mutex_new() AS TCOD_mutex_t
DECLARE SUB TCOD_mutex_in(BYVAL AS TCOD_mutex_t)
DECLARE SUB TCOD_mutex_out(BYVAL AS TCOD_mutex_t)
DECLARE SUB TCOD_mutex_delete(BYVAL AS TCOD_mutex_t)
DECLARE FUNCTION TCOD_semaphore_new(BYVAL AS INTEGER) AS TCOD_semaphore_t
DECLARE SUB TCOD_semaphore_lock(BYVAL AS TCOD_semaphore_t)
DECLARE SUB TCOD_semaphore_unlock(BYVAL AS TCOD_semaphore_t)
DECLARE SUB TCOD_semaphore_delete(BYVAL AS TCOD_semaphore_t)
DECLARE FUNCTION TCOD_condition_new() AS TCOD_cond_t
DECLARE SUB TCOD_condition_signal(BYVAL AS TCOD_cond_t)
DECLARE SUB TCOD_condition_broadcast(BYVAL AS TCOD_cond_t)
DECLARE SUB TCOD_condition_wait(BYVAL AS TCOD_cond_t, BYVAL AS TCOD_mutex_t)
DECLARE SUB TCOD_condition_delete(BYVAL AS TCOD_cond_t)

TYPE SDL_renderer_t AS SUB(BYVAL AS ANY PTR)

DECLARE SUB TCOD_sys_register_SDL_renderer(BYVAL AS SDL_renderer_t)

#ENDIF ' _TCOD_SYS_H

#IFNDEF _TCOD_RANDOM_H
#DEFINE _TCOD_RANDOM_H

#IFNDEF _TCOD_RANDOM_TYPES_H
#DEFINE _TCOD_RANDOM_TYPES_H

ENUM TCOD_random_algo_t
  TCOD_RNG_MT
  TCOD_RNG_CMWC
END ENUM

#ENDIF ' _TCOD_RANDOM_TYPES_H

TYPE TCOD_random_t AS ANY PTR

DECLARE FUNCTION TCOD_random_get_instance() AS TCOD_random_t
DECLARE FUNCTION TCOD_random_new(BYVAL AS TCOD_random_algo_t) AS TCOD_random_t
DECLARE FUNCTION TCOD_random_save(BYVAL AS TCOD_random_t) AS TCOD_random_t
DECLARE SUB TCOD_random_restore(BYVAL AS TCOD_random_t, BYVAL AS TCOD_random_t)
DECLARE FUNCTION TCOD_random_new_from_seed(BYVAL AS TCOD_random_algo_t, BYVAL AS uint32) AS TCOD_random_t
DECLARE FUNCTION TCOD_random_get_int(BYVAL AS TCOD_random_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION TCOD_random_get_float(BYVAL AS TCOD_random_t, BYVAL AS SINGLE, BYVAL AS SINGLE) AS SINGLE
DECLARE SUB TCOD_random_delete(BYVAL AS TCOD_random_t)
DECLARE FUNCTION TCOD_random_get_gaussian_double(BYVAL AS TCOD_random_t, BYVAL AS DOUBLE, BYVAL AS DOUBLE) AS DOUBLE
DECLARE FUNCTION TCOD_random_get_gaussian_float(BYVAL AS TCOD_random_t, BYVAL AS SINGLE, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_random_get_gaussian_int(BYVAL AS TCOD_random_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION TCOD_random_get_gaussian_double_range(BYVAL AS TCOD_random_t, BYVAL AS DOUBLE, BYVAL AS DOUBLE) AS DOUBLE
DECLARE FUNCTION TCOD_random_get_gaussian_float_range(BYVAL AS TCOD_random_t, BYVAL AS SINGLE, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_random_get_gaussian_int_range(BYVAL AS TCOD_random_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION TCOD_random_get_gaussian_double_range_custom(BYVAL AS TCOD_random_t, BYVAL AS DOUBLE, BYVAL AS DOUBLE, BYVAL AS DOUBLE) AS DOUBLE
DECLARE FUNCTION TCOD_random_get_gaussian_float_range_custom(BYVAL AS TCOD_random_t, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_random_get_gaussian_int_range_custom(BYVAL AS TCOD_random_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION TCOD_random_get_gaussian_double_inv(BYVAL AS TCOD_random_t, BYVAL AS DOUBLE, BYVAL AS DOUBLE) AS DOUBLE
DECLARE FUNCTION TCOD_random_get_gaussian_float_inv(BYVAL AS TCOD_random_t, BYVAL AS SINGLE, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_random_get_gaussian_int_inv(BYVAL AS TCOD_random_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION TCOD_random_get_gaussian_double_range_inv(BYVAL AS TCOD_random_t, BYVAL AS DOUBLE, BYVAL AS DOUBLE) AS DOUBLE
DECLARE FUNCTION TCOD_random_get_gaussian_float_range_inv(BYVAL AS TCOD_random_t, BYVAL AS SINGLE, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_random_get_gaussian_int_range_inv(BYVAL AS TCOD_random_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION TCOD_random_get_gaussian_double_range_custom_inv(BYVAL AS TCOD_random_t, BYVAL AS DOUBLE, BYVAL AS DOUBLE, BYVAL AS DOUBLE) AS DOUBLE
DECLARE FUNCTION TCOD_random_get_gaussian_float_range_custom_inv(BYVAL AS TCOD_random_t, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_random_get_gaussian_int_range_custom_inv(BYVAL AS TCOD_random_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER) AS INTEGER

#ENDIF ' _TCOD_RANDOM_H

#IFNDEF _TCOD_MOUSE_H
#DEFINE _TCOD_MOUSE_H

#IFNDEF _TCOD_MOUSE_TYPES_H
#DEFINE _TCOD_MOUSE_TYPES_H

TYPE TCOD_mouse_t
  AS INTEGER x, y
  AS INTEGER dx, dy
  AS INTEGER cx, cy
  AS INTEGER dcx, dcy
  AS bool lbutton
  AS bool rbutton
  AS bool mbutton
  AS bool lbutton_pressed
  AS bool rbutton_pressed
  AS bool mbutton_pressed
  AS bool wheel_up
  AS bool wheel_down
END TYPE

#ENDIF ' _TCOD_MOUSE_TYPES_H

DECLARE SUB TCOD_mouse_show_cursor(BYVAL AS bool)
DECLARE FUNCTION TCOD_mouse_get_status() AS TCOD_mouse_t
DECLARE FUNCTION TCOD_mouse_is_cursor_visible() AS bool
DECLARE SUB TCOD_mouse_move(BYVAL AS INTEGER, BYVAL AS INTEGER)

#ENDIF ' _TCOD_MOUSE_H

#IFNDEF _TCOD_BRESENHAM_H
#DEFINE _TCOD_BRESENHAM_H

TYPE TCOD_line_listener_t AS FUNCTION(BYVAL AS INTEGER, BYVAL AS INTEGER) AS bool

DECLARE SUB TCOD_line_init(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE FUNCTION TCOD_line_step(BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR) AS bool
DECLARE FUNCTION TCOD_line(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_line_listener_t) AS bool

TYPE TCOD_bresenham_data_t
  AS INTEGER stepx
  AS INTEGER stepy
  AS INTEGER e
  AS INTEGER deltax
  AS INTEGER deltay
  AS INTEGER origx
  AS INTEGER origy
  AS INTEGER destx
  AS INTEGER desty
END TYPE

DECLARE SUB TCOD_line_init_mt(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_bresenham_data_t PTR)
DECLARE FUNCTION TCOD_line_step_mt(BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR, BYVAL AS TCOD_bresenham_data_t PTR) AS bool
DECLARE FUNCTION TCOD_line_mt(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_line_listener_t, BYVAL AS TCOD_bresenham_data_t PTR) AS bool

#ENDIF ' _TCOD_BRESENHAM_H

#IFNDEF _TCOD_PERLIN_H
#DEFINE _TCOD_PERLIN_H

TYPE TCOD_noise_t AS ANY PTR

#IFNDEF _TCOD_NOISE_DEFAULTS
#DEFINE _TCOD_NOISE_DEFAULTS
#DEFINE TCOD_NOISE_MAX_OCTAVES 128
#DEFINE TCOD_NOISE_MAX_DIMENSIONS 4
#DEFINE TCOD_NOISE_DEFAULT_HURST 0.5f
#DEFINE TCOD_NOISE_DEFAULT_LACUNARITY 2.0f
#ENDIF ' _TCOD_NOISE_DEFAULTS

DECLARE FUNCTION TCOD_noise_new(BYVAL AS INTEGER, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS TCOD_random_t) AS TCOD_noise_t
DECLARE FUNCTION TCOD_noise_perlin(BYVAL AS TCOD_noise_t, BYVAL AS SINGLE PTR) AS SINGLE
DECLARE FUNCTION TCOD_noise_fbm_perlin(BYVAL AS TCOD_noise_t, BYVAL AS SINGLE PTR, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_noise_turbulence_perlin(BYVAL AS TCOD_noise_t, BYVAL AS SINGLE PTR, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_noise_simplex(BYVAL AS TCOD_noise_t, BYVAL AS SINGLE PTR) AS SINGLE
DECLARE FUNCTION TCOD_noise_fbm_simplex(BYVAL AS TCOD_noise_t, BYVAL AS SINGLE PTR, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_noise_turbulence_simplex(BYVAL AS TCOD_noise_t, BYVAL AS SINGLE PTR, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_noise_wavelet(BYVAL AS TCOD_noise_t, BYVAL AS SINGLE PTR) AS SINGLE
DECLARE FUNCTION TCOD_noise_fbm_wavelet(BYVAL AS TCOD_noise_t, BYVAL AS SINGLE PTR, BYVAL AS SINGLE) AS SINGLE
DECLARE FUNCTION TCOD_noise_turbulence_wavelet(BYVAL AS TCOD_noise_t, BYVAL AS SINGLE PTR, BYVAL AS SINGLE) AS SINGLE
DECLARE SUB TCOD_noise_delete(BYVAL AS TCOD_noise_t)

#ENDIF ' _TCOD_PERLIN_H

#IFNDEF _TCOD_FOV_H
#DEFINE _TCOD_FOV_H

TYPE TCOD_map_t AS ANY PTR

#IFNDEF _TCOD_FOV_TYPES_H
#DEFINE _TCOD_FOV_TYPES_H

ENUM TCOD_fov_algorithm_t
  FOV_BASIC
  FOV_DIAMOND
  FOV_SHADOW
  FOV_PERMISSIVE_0
  FOV_PERMISSIVE_1
  FOV_PERMISSIVE_2
  FOV_PERMISSIVE_3
  FOV_PERMISSIVE_4
  FOV_PERMISSIVE_5
  FOV_PERMISSIVE_6
  FOV_PERMISSIVE_7
  FOV_PERMISSIVE_8
  FOV_RESTRICTIVE
  NB_FOV_ALGORITHMS
END ENUM

#DEFINE FOV_PERMISSIVE(x) ((TCOD_fov_algorithm_t)(FOV_PERMISSIVE_0 + (x)))
#ENDIF ' _TCOD_FOV_TYPES_H

DECLARE FUNCTION TCOD_map_new(BYVAL AS INTEGER, BYVAL AS INTEGER) AS TCOD_map_t
DECLARE SUB TCOD_map_clear(BYVAL AS TCOD_map_t, BYVAL AS bool, BYVAL AS bool)
DECLARE SUB TCOD_map_copy(BYVAL AS TCOD_map_t, BYVAL AS TCOD_map_t)
DECLARE SUB TCOD_map_set_properties(BYVAL AS TCOD_map_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS bool, BYVAL AS bool)
DECLARE SUB TCOD_map_delete(BYVAL AS TCOD_map_t)
DECLARE SUB TCOD_map_compute_fov(BYVAL AS TCOD_map_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS bool, BYVAL AS TCOD_fov_algorithm_t)
DECLARE FUNCTION TCOD_map_is_in_fov(BYVAL AS TCOD_map_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS bool
DECLARE SUB TCOD_map_set_in_fov(BYVAL AS TCOD_map_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS bool)
DECLARE FUNCTION TCOD_map_is_transparent(BYVAL AS TCOD_map_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS bool
DECLARE FUNCTION TCOD_map_is_walkable(BYVAL AS TCOD_map_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS bool
DECLARE FUNCTION TCOD_map_get_width(BYVAL AS TCOD_map_t) AS INTEGER
DECLARE FUNCTION TCOD_map_get_height(BYVAL AS TCOD_map_t) AS INTEGER
DECLARE FUNCTION TCOD_map_get_nb_cells(BYVAL AS TCOD_map_t) AS INTEGER

#ENDIF ' _TCOD_FOV_H

#IFNDEF _TCOD_PATH_H
#DEFINE _TCOD_PATH_H

TYPE TCOD_path_func_t AS FUNCTION(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS ANY PTR) AS SINGLE
TYPE TCOD_path_t AS ANY PTR

DECLARE FUNCTION TCOD_path_new_using_map(BYVAL AS TCOD_map_t, BYVAL AS SINGLE) AS TCOD_path_t
DECLARE FUNCTION TCOD_path_new_using_function(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_path_func_t, BYVAL AS ANY PTR, BYVAL AS SINGLE) AS TCOD_path_t
DECLARE FUNCTION TCOD_path_compute(BYVAL AS TCOD_path_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER) AS bool
DECLARE FUNCTION TCOD_path_walk(BYVAL AS TCOD_path_t, BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR, BYVAL AS bool) AS bool
DECLARE FUNCTION TCOD_path_is_empty(BYVAL AS TCOD_path_t) AS bool
DECLARE FUNCTION TCOD_path_size(BYVAL AS TCOD_path_t) AS INTEGER
DECLARE SUB TCOD_path_get(BYVAL AS TCOD_path_t, BYVAL AS INTEGER, BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR)
DECLARE SUB TCOD_path_get_origin(BYVAL AS TCOD_path_t, BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR)
DECLARE SUB TCOD_path_get_destination(BYVAL AS TCOD_path_t, BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR)
DECLARE SUB TCOD_path_delete(BYVAL AS TCOD_path_t)

TYPE TCOD_dijkstra_t AS ANY PTR

DECLARE FUNCTION TCOD_dijkstra_new(BYVAL AS TCOD_map_t, BYVAL AS SINGLE) AS TCOD_dijkstra_t
DECLARE FUNCTION TCOD_dijkstra_new_using_function(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS TCOD_path_func_t, BYVAL AS ANY PTR, BYVAL AS SINGLE) AS TCOD_dijkstra_t
DECLARE SUB TCOD_dijkstra_compute(BYVAL AS TCOD_dijkstra_t, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE FUNCTION TCOD_dijkstra_get_distance(BYVAL AS TCOD_dijkstra_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS SINGLE
DECLARE FUNCTION TCOD_dijkstra_path_set(BYVAL AS TCOD_dijkstra_t, BYVAL AS INTEGER, BYVAL AS INTEGER) AS bool
DECLARE FUNCTION TCOD_dijkstra_is_empty(BYVAL AS TCOD_dijkstra_t) AS bool
DECLARE FUNCTION TCOD_dijkstra_size(BYVAL AS TCOD_dijkstra_t) AS INTEGER
DECLARE SUB TCOD_dijkstra_get(BYVAL AS TCOD_dijkstra_t, BYVAL AS INTEGER, BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR)
DECLARE FUNCTION TCOD_dijkstra_path_walk(BYVAL AS TCOD_dijkstra_t, BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR) AS bool
DECLARE SUB TCOD_dijkstra_delete(BYVAL AS TCOD_dijkstra_t)

#ENDIF ' _TCOD_PATH_H

#IFNDEF _TCOD_LEX_H
#DEFINE _TCOD_LEX_H
#DEFINE TCOD_LEX_FLAG_NOCASE 1
#DEFINE TCOD_LEX_FLAG_NESTING_COMMENT 2
#DEFINE TCOD_LEX_FLAG_TOKENIZE_COMMENTS 4
#DEFINE TCOD_LEX_ERROR -1
#DEFINE TCOD_LEX_UNKNOWN 0
#DEFINE TCOD_LEX_SYMBOL 1
#DEFINE TCOD_LEX_KEYWORD 2
#DEFINE TCOD_LEX_IDEN 3
#DEFINE TCOD_LEX_STRING 4
#DEFINE TCOD_LEX_INTEGER 5
#DEFINE TCOD_LEX_FLOAT 6
#DEFINE TCOD_LEX_CHAR 7
#DEFINE TCOD_LEX_EOF 8
#DEFINE TCOD_LEX_COMMENT 9
#DEFINE TCOD_LEX_MAX_SYMBOLS 100
#DEFINE TCOD_LEX_SYMBOL_SIZE 5
#DEFINE TCOD_LEX_MAX_KEYWORDS 100
#DEFINE TCOD_LEX_KEYWORD_SIZE 20

TYPE TCOD_lex_t
  AS INTEGER file_line, token_type, token_int_val, token_idx
  AS SINGLE token_float_val
  AS ZSTRING PTR tok
  AS INTEGER toklen
  AS UBYTE lastStringDelim
  AS ZSTRING PTR pos
  AS ZSTRING PTR buf
  AS ZSTRING PTR filename
  AS ZSTRING PTR last_javadoc_comment
  AS INTEGER nb_symbols, nb_keywords, flags
  AS ZSTRING*TCOD_LEX_SYMBOL_SIZE symbols(TCOD_LEX_MAX_SYMBOLS-1)
  AS ZSTRING*TCOD_LEX_KEYWORD_SIZE keywords(TCOD_LEX_MAX_KEYWORDS-1)
  AS CONST ZSTRING PTR simpleCmt
  AS CONST ZSTRING PTR cmtStart, cmtStop, javadocCmtStart
  AS CONST ZSTRING PTR stringDelim
  AS bool javadoc_read
  AS bool allocBuf
  AS bool savept
END TYPE

DECLARE FUNCTION TCOD_lex_new_intern() AS TCOD_lex_t PTR
DECLARE FUNCTION TCOD_lex_new(BYVAL AS CONST ZSTRING PTR PTR, BYVAL AS CONST ZSTRING PTR PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER) AS TCOD_lex_t PTR
DECLARE SUB TCOD_lex_delete(BYVAL AS TCOD_lex_t PTR)
DECLARE SUB TCOD_lex_set_data_buffer(BYVAL AS TCOD_lex_t PTR, BYVAL AS ZSTRING PTR)
DECLARE FUNCTION TCOD_lex_set_data_file(BYVAL AS TCOD_lex_t PTR, BYVAL AS CONST ZSTRING PTR) AS bool
DECLARE FUNCTION TCOD_lex_parse(BYVAL AS TCOD_lex_t PTR) AS INTEGER
DECLARE FUNCTION TCOD_lex_parse_until_token_type(BYVAL AS TCOD_lex_t PTR, BYVAL AS INTEGER) AS INTEGER
DECLARE FUNCTION TCOD_lex_parse_until_token_value(BYVAL AS TCOD_lex_t PTR, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION TCOD_lex_expect_token_type(BYVAL AS TCOD_lex_t PTR, BYVAL AS INTEGER) AS bool
DECLARE FUNCTION TCOD_lex_expect_token_value(BYVAL AS TCOD_lex_t PTR, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR) AS bool
DECLARE SUB TCOD_lex_savepoint(BYVAL AS TCOD_lex_t PTR, BYVAL AS TCOD_lex_t PTR)
DECLARE SUB TCOD_lex_restore(BYVAL AS TCOD_lex_t PTR, BYVAL AS TCOD_lex_t PTR)
DECLARE FUNCTION TCOD_lex_get_last_javadoc(BYVAL AS TCOD_lex_t PTR) AS ZSTRING PTR

DECLARE FUNCTION TCOD_lex_get_token_name(BYVAL AS INTEGER) AS CONST ZSTRING PTR

DECLARE FUNCTION TCOD_lex_get_last_error() AS ZSTRING PTR
DECLARE FUNCTION TCOD_lex_hextoint(BYVAL AS UBYTE) AS INTEGER

#ENDIF ' _TCOD_LEX_H

#IFNDEF _TCOD_PARSER_H
#DEFINE _TCOD_PARSER_H

ENUM TCOD_value_type_t
  TCOD_TYPE_NONE
  TCOD_TYPE_BOOL
  TCOD_TYPE_CHAR
  TCOD_TYPE_INT
  TCOD_TYPE_FLOAT
  TCOD_TYPE_STRING
  TCOD_TYPE_COLOR
  TCOD_TYPE_DICE
  TCOD_TYPE_VALUELIST00
  TCOD_TYPE_VALUELIST01
  TCOD_TYPE_VALUELIST02
  TCOD_TYPE_VALUELIST03
  TCOD_TYPE_VALUELIST04
  TCOD_TYPE_VALUELIST05
  TCOD_TYPE_VALUELIST06
  TCOD_TYPE_VALUELIST07
  TCOD_TYPE_VALUELIST08
  TCOD_TYPE_VALUELIST09
  TCOD_TYPE_VALUELIST10
  TCOD_TYPE_VALUELIST11
  TCOD_TYPE_VALUELIST12
  TCOD_TYPE_VALUELIST13
  TCOD_TYPE_VALUELIST14
  TCOD_TYPE_VALUELIST15
  TCOD_TYPE_CUSTOM00
  TCOD_TYPE_CUSTOM01
  TCOD_TYPE_CUSTOM02
  TCOD_TYPE_CUSTOM03
  TCOD_TYPE_CUSTOM04
  TCOD_TYPE_CUSTOM05
  TCOD_TYPE_CUSTOM06
  TCOD_TYPE_CUSTOM07
  TCOD_TYPE_CUSTOM08
  TCOD_TYPE_CUSTOM09
  TCOD_TYPE_CUSTOM10
  TCOD_TYPE_CUSTOM11
  TCOD_TYPE_CUSTOM12
  TCOD_TYPE_CUSTOM13
  TCOD_TYPE_CUSTOM14
  TCOD_TYPE_CUSTOM15
  TCOD_TYPE_LIST = 1024
END ENUM

TYPE TCOD_dice_t
  AS INTEGER nb_dices
  AS INTEGER nb_faces
  AS SINGLE multiplier
  AS SINGLE addsub
END TYPE

UNION TCOD_value_t
  AS bool b
  AS UBYTE c
  AS int32 i
  AS SINGLE f
  AS ZSTRING PTR s
  AS TCOD_color_t col
  AS TCOD_dice_t dice
  AS TCOD_list_t list
  AS ANY PTR custom
END UNION

TYPE TCOD_parser_struct_t AS ANY PTR

DECLARE FUNCTION TCOD_struct_get_name(BYVAL AS TCOD_parser_struct_t) AS CONST ZSTRING PTR

DECLARE SUB TCOD_struct_add_property(BYVAL AS TCOD_parser_struct_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS TCOD_value_type_t, BYVAL AS bool)
DECLARE SUB TCOD_struct_add_list_property(BYVAL AS TCOD_parser_struct_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS TCOD_value_type_t, BYVAL AS bool)
DECLARE SUB TCOD_struct_add_value_list(BYVAL AS TCOD_parser_struct_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR PTR, BYVAL AS bool)
DECLARE SUB TCOD_struct_add_value_list_sized(BYVAL AS TCOD_parser_struct_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS CONST ZSTRING PTR PTR, BYVAL AS INTEGER, BYVAL AS bool)
DECLARE SUB TCOD_struct_add_flag(BYVAL AS TCOD_parser_struct_t, BYVAL AS CONST ZSTRING PTR)
DECLARE SUB TCOD_struct_add_structure(BYVAL AS TCOD_parser_struct_t, BYVAL AS TCOD_parser_struct_t)
DECLARE FUNCTION TCOD_struct_is_mandatory(BYVAL AS TCOD_parser_struct_t, BYVAL AS CONST ZSTRING PTR) AS bool
DECLARE FUNCTION TCOD_struct_get_type(BYVAL AS TCOD_parser_struct_t, BYVAL AS CONST ZSTRING PTR) AS TCOD_value_type_t

TYPE TCOD_parser_listener_t
  new_struct AS FUNCTION(BYVAL AS TCOD_parser_struct_t, BYVAL AS CONST ZSTRING PTR) AS bool
  new_flag AS FUNCTION(BYVAL AS CONST ZSTRING PTR) AS bool
  new_property AS FUNCTION(BYVAL AS CONST ZSTRING PTR, BYVAL AS TCOD_value_type_t, BYVAL AS TCOD_value_t) AS bool
  end_struct AS FUNCTION(BYVAL AS TCOD_parser_struct_t, BYVAL AS CONST ZSTRING PTR) AS bool
  error AS SUB(BYVAL AS CONST ZSTRING PTR)
END TYPE

TYPE TCOD_parser_custom_t AS FUNCTION(BYVAL AS TCOD_lex_t PTR, BYVAL AS TCOD_parser_listener_t PTR, BYVAL AS TCOD_parser_struct_t, BYVAL AS ZSTRING PTR) AS TCOD_value_t
TYPE TCOD_parser_t AS ANY PTR

DECLARE FUNCTION TCOD_parser_new() AS TCOD_parser_t
DECLARE FUNCTION TCOD_parser_new_struct(BYVAL AS TCOD_parser_t, BYVAL AS ZSTRING PTR) AS TCOD_parser_struct_t
DECLARE FUNCTION TCOD_parser_new_custom_type(BYVAL AS TCOD_parser_t, BYVAL AS TCOD_parser_custom_t) AS TCOD_value_type_t
DECLARE SUB TCOD_parser_run(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS TCOD_parser_listener_t PTR)
DECLARE SUB TCOD_parser_delete(BYVAL AS TCOD_parser_t)
DECLARE SUB TCOD_parser_error(BYVAL AS CONST ZSTRING PTR, ...)
DECLARE FUNCTION TCOD_parser_get_bool_property(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR) AS bool
DECLARE FUNCTION TCOD_parser_get_char_property(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION TCOD_parser_get_int_property(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION TCOD_parser_get_float_property(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR) AS SINGLE

DECLARE FUNCTION TCOD_parser_get_string_property(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR) AS CONST ZSTRING PTR

DECLARE FUNCTION TCOD_parser_get_color_property(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR) AS TCOD_color_t
DECLARE FUNCTION TCOD_parser_get_dice_property(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR) AS TCOD_dice_t
DECLARE SUB TCOD_parser_get_dice_property_py(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS TCOD_dice_t PTR)
DECLARE FUNCTION TCOD_parser_get_custom_property(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR) AS ANY PTR
DECLARE FUNCTION TCOD_parser_get_list_property(BYVAL AS TCOD_parser_t, BYVAL AS CONST ZSTRING PTR, BYVAL AS TCOD_value_type_t) AS TCOD_list_t

TYPE TCOD_struct_int_t
  AS ZSTRING PTR name
  AS TCOD_list_t flags
  AS TCOD_list_t props
  AS TCOD_list_t lists
  AS TCOD_list_t structs
END TYPE

TYPE TCOD_parser_int_t
  AS TCOD_list_t structs
  AS TCOD_parser_custom_t customs(15)
  AS bool fatal
  AS TCOD_list_t props
END TYPE

DECLARE FUNCTION TCOD_parse_bool_value() AS TCOD_value_t
DECLARE FUNCTION TCOD_parse_char_value() AS TCOD_value_t
DECLARE FUNCTION TCOD_parse_integer_value() AS TCOD_value_t
DECLARE FUNCTION TCOD_parse_float_value() AS TCOD_value_t
DECLARE FUNCTION TCOD_parse_string_value() AS TCOD_value_t
DECLARE FUNCTION TCOD_parse_color_value() AS TCOD_value_t
DECLARE FUNCTION TCOD_parse_dice_value() AS TCOD_value_t
DECLARE FUNCTION TCOD_parse_value_list_value(BYVAL AS TCOD_struct_int_t PTR, BYVAL AS INTEGER) AS TCOD_value_t
DECLARE FUNCTION TCOD_parse_property_value(BYVAL AS TCOD_parser_int_t PTR, BYVAL AS TCOD_parser_struct_t, BYVAL AS ZSTRING PTR, BYVAL AS bool) AS TCOD_value_t

#ENDIF ' _TCOD_PARSER_H

#IFNDEF _TCOD_TREE_H
#DEFINE _TCOD_TREE_H

TYPE _TCOD_tree_t
  AS _TCOD_tree_t PTR next
  AS _TCOD_tree_t PTR father
  AS _TCOD_tree_t PTR sons
END TYPE

TYPE AS _TCOD_tree_t TCOD_tree_t

DECLARE FUNCTION TCOD_tree_new() AS TCOD_tree_t PTR
DECLARE SUB TCOD_tree_add_son(BYVAL AS TCOD_tree_t PTR, BYVAL AS TCOD_tree_t PTR)

#ENDIF ' _TCOD_TREE_H

#IFNDEF _TCOD_BSP_H
#DEFINE _TCOD_BSP_H

TYPE TCOD_bsp_t
  AS TCOD_tree_t tree
  AS INTEGER x, y, w, h
  AS INTEGER position
  AS uint8 level
  AS bool horizontal
END TYPE

TYPE TCOD_bsp_callback_t AS FUNCTION(BYVAL AS TCOD_bsp_t PTR, BYVAL AS ANY PTR) AS bool

DECLARE FUNCTION TCOD_bsp_new() AS TCOD_bsp_t PTR
DECLARE FUNCTION TCOD_bsp_new_with_size(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER) AS TCOD_bsp_t PTR
DECLARE SUB TCOD_bsp_delete(BYVAL AS TCOD_bsp_t PTR)
DECLARE FUNCTION TCOD_bsp_left(BYVAL AS TCOD_bsp_t PTR) AS TCOD_bsp_t PTR
DECLARE FUNCTION TCOD_bsp_right(BYVAL AS TCOD_bsp_t PTR) AS TCOD_bsp_t PTR
DECLARE FUNCTION TCOD_bsp_father(BYVAL AS TCOD_bsp_t PTR) AS TCOD_bsp_t PTR
DECLARE FUNCTION TCOD_bsp_is_leaf(BYVAL AS TCOD_bsp_t PTR) AS bool
DECLARE FUNCTION TCOD_bsp_traverse_pre_order(BYVAL AS TCOD_bsp_t PTR, BYVAL AS TCOD_bsp_callback_t, BYVAL AS ANY PTR) AS bool
DECLARE FUNCTION TCOD_bsp_traverse_in_order(BYVAL AS TCOD_bsp_t PTR, BYVAL AS TCOD_bsp_callback_t, BYVAL AS ANY PTR) AS bool
DECLARE FUNCTION TCOD_bsp_traverse_post_order(BYVAL AS TCOD_bsp_t PTR, BYVAL AS TCOD_bsp_callback_t, BYVAL AS ANY PTR) AS bool
DECLARE FUNCTION TCOD_bsp_traverse_level_order(BYVAL AS TCOD_bsp_t PTR, BYVAL AS TCOD_bsp_callback_t, BYVAL AS ANY PTR) AS bool
DECLARE FUNCTION TCOD_bsp_traverse_inverted_level_order(BYVAL AS TCOD_bsp_t PTR, BYVAL AS TCOD_bsp_callback_t, BYVAL AS ANY PTR) AS bool
DECLARE FUNCTION TCOD_bsp_contains(BYVAL AS TCOD_bsp_t PTR, BYVAL AS INTEGER, BYVAL AS INTEGER) AS bool
DECLARE FUNCTION TCOD_bsp_find_node(BYVAL AS TCOD_bsp_t PTR, BYVAL AS INTEGER, BYVAL AS INTEGER) AS TCOD_bsp_t PTR
DECLARE SUB TCOD_bsp_resize(BYVAL AS TCOD_bsp_t PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER)
DECLARE SUB TCOD_bsp_split_once(BYVAL AS TCOD_bsp_t PTR, BYVAL AS bool, BYVAL AS INTEGER)
DECLARE SUB TCOD_bsp_split_recursive(BYVAL AS TCOD_bsp_t PTR, BYVAL AS TCOD_random_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_bsp_remove_sons(BYVAL AS TCOD_bsp_t PTR)

#ENDIF ' _TCOD_BSP_H

#IFNDEF _TCOD_HEIGHTMAP_H
#DEFINE _TCOD_HEIGHTMAP_H

TYPE TCOD_heightmap_t
  AS INTEGER w, h
  AS SINGLE PTR values
END TYPE

DECLARE FUNCTION TCOD_heightmap_new(BYVAL AS INTEGER, BYVAL AS INTEGER) AS TCOD_heightmap_t PTR
DECLARE SUB TCOD_heightmap_delete(BYVAL AS TCOD_heightmap_t PTR)
DECLARE FUNCTION TCOD_heightmap_get_value(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS INTEGER, BYVAL AS INTEGER) AS SINGLE
DECLARE FUNCTION TCOD_heightmap_get_interpolated_value(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS SINGLE, BYVAL AS SINGLE) AS SINGLE
DECLARE SUB TCOD_heightmap_set_value(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS SINGLE)
DECLARE FUNCTION TCOD_heightmap_get_slope(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS INTEGER, BYVAL AS INTEGER) AS SINGLE
DECLARE SUB TCOD_heightmap_get_normal(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE PTR, BYVAL AS SINGLE PTR)
DECLARE FUNCTION TCOD_heightmap_count_cells(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS SINGLE, BYVAL AS SINGLE) AS INTEGER
DECLARE FUNCTION TCOD_heightmap_has_land_on_border(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS SINGLE) AS bool
DECLARE SUB TCOD_heightmap_get_minmax(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS SINGLE PTR, BYVAL AS SINGLE PTR)
DECLARE SUB TCOD_heightmap_copy(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS TCOD_heightmap_t PTR)
DECLARE SUB TCOD_heightmap_add(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS SINGLE)
DECLARE SUB TCOD_heightmap_scale(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS SINGLE)
DECLARE SUB TCOD_heightmap_clamp(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_heightmap_normalize(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_heightmap_clear(BYVAL AS TCOD_heightmap_t PTR)
DECLARE SUB TCOD_heightmap_lerp_hm(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS TCOD_heightmap_t PTR, BYVAL AS SINGLE)
DECLARE SUB TCOD_heightmap_add_hm(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS TCOD_heightmap_t PTR)
DECLARE SUB TCOD_heightmap_multiply_hm(BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS CONST TCOD_heightmap_t PTR, BYVAL AS TCOD_heightmap_t PTR)
DECLARE SUB TCOD_heightmap_add_hill(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_heightmap_dig_hill(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_heightmap_dig_bezier(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS INTEGER PTR, BYVAL AS INTEGER PTR, BYVAL AS SINGLE PTR, BYVAL AS SINGLE PTR, BYVAL AS SINGLE PTR, BYVAL AS SINGLE PTR)
DECLARE SUB TCOD_heightmap_rain_erosion(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS INTEGER, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS TCOD_random_t)
DECLARE SUB TCOD_heightmap_kernel_transform(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS INTEGER, BYVAL AS CONST INTEGER PTR, BYVAL AS CONST INTEGER PTR, BYVAL AS CONST SINGLE PTR, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_heightmap_add_voronoi(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST SINGLE PTR, BYVAL AS TCOD_random_t)
DECLARE SUB TCOD_heightmap_add_fbm(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS TCOD_noise_t, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_heightmap_scale_fbm(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS TCOD_noise_t, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE, BYVAL AS SINGLE)
DECLARE SUB TCOD_heightmap_islandify(BYVAL AS TCOD_heightmap_t PTR, BYVAL AS SINGLE, BYVAL AS TCOD_random_t)

#ENDIF ' _TCOD_HEIGHTMAP_H

#IFNDEF _TCOD_ZIP_H
#DEFINE _TCOD_ZIP_H

TYPE TCOD_zip_t AS ANY PTR

DECLARE FUNCTION TCOD_zip_new() AS TCOD_zip_t
DECLARE SUB TCOD_zip_delete(BYVAL AS TCOD_zip_t)
DECLARE SUB TCOD_zip_put_char(BYVAL AS TCOD_zip_t, BYVAL AS UBYTE)
DECLARE SUB TCOD_zip_put_int(BYVAL AS TCOD_zip_t, BYVAL AS INTEGER)
DECLARE SUB TCOD_zip_put_float(BYVAL AS TCOD_zip_t, BYVAL AS SINGLE)
DECLARE SUB TCOD_zip_put_string(BYVAL AS TCOD_zip_t, BYVAL AS CONST ZSTRING PTR)
DECLARE SUB TCOD_zip_put_color(BYVAL AS TCOD_zip_t, BYVAL AS CONST TCOD_color_t)
DECLARE SUB TCOD_zip_put_image(BYVAL AS TCOD_zip_t, BYVAL AS CONST TCOD_image_t)
DECLARE SUB TCOD_zip_put_console(BYVAL AS TCOD_zip_t, BYVAL AS CONST TCOD_console_t)
DECLARE SUB TCOD_zip_put_data(BYVAL AS TCOD_zip_t, BYVAL AS INTEGER, BYVAL AS CONST ANY PTR)
DECLARE FUNCTION TCOD_zip_get_current_bytes(BYVAL AS TCOD_zip_t) AS uint32
DECLARE FUNCTION TCOD_zip_save_to_file(BYVAL AS TCOD_zip_t, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION TCOD_zip_load_from_file(BYVAL AS TCOD_zip_t, BYVAL AS CONST ZSTRING PTR) AS INTEGER
DECLARE FUNCTION TCOD_zip_get_char(BYVAL AS TCOD_zip_t) AS UBYTE
DECLARE FUNCTION TCOD_zip_get_int(BYVAL AS TCOD_zip_t) AS INTEGER
DECLARE FUNCTION TCOD_zip_get_float(BYVAL AS TCOD_zip_t) AS SINGLE

DECLARE FUNCTION TCOD_zip_get_string(BYVAL AS TCOD_zip_t) AS CONST ZSTRING PTR

DECLARE FUNCTION TCOD_zip_get_color(BYVAL AS TCOD_zip_t) AS TCOD_color_t
DECLARE FUNCTION TCOD_zip_get_image(BYVAL AS TCOD_zip_t) AS TCOD_image_t
DECLARE FUNCTION TCOD_zip_get_console(BYVAL AS TCOD_zip_t) AS TCOD_console_t
DECLARE FUNCTION TCOD_zip_get_data(BYVAL AS TCOD_zip_t, BYVAL AS INTEGER, BYVAL AS ANY PTR) AS INTEGER
DECLARE FUNCTION TCOD_zip_get_remaining_bytes(BYVAL AS TCOD_zip_t) AS uint32
DECLARE SUB TCOD_zip_skip_bytes(BYVAL AS TCOD_zip_t, BYVAL AS uint32)

#ENDIF ' _TCOD_ZIP_H

#IFNDEF _TCOD_NAMEGEN_H
#DEFINE _TCOD_NAMEGEN_H

TYPE TCOD_namegen_t AS ANY PTR

DECLARE SUB TCOD_namegen_parse(BYVAL AS CONST ZSTRING PTR, BYVAL AS TCOD_random_t)
DECLARE FUNCTION TCOD_namegen_generate(BYVAL AS ZSTRING PTR, BYVAL AS bool) AS ZSTRING PTR
DECLARE FUNCTION TCOD_namegen_generate_custom(BYVAL AS ZSTRING PTR, BYVAL AS ZSTRING PTR, BYVAL AS bool) AS ZSTRING PTR
DECLARE FUNCTION TCOD_namegen_get_sets() AS TCOD_list_t
DECLARE SUB TCOD_namegen_destroy()

#ENDIF ' _TCOD_NAMEGEN_H

#IFNDEF _TCOD_TEXT_H_
#DEFINE _TCOD_TEXT_H_

TYPE TCOD_text_t AS ANY PTR

DECLARE FUNCTION TCOD_text_init(BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS INTEGER) AS TCOD_text_t
DECLARE SUB TCOD_text_set_properties(BYVAL AS TCOD_text_t, BYVAL AS INTEGER, BYVAL AS INTEGER, BYVAL AS CONST ZSTRING PTR, BYVAL AS INTEGER)
DECLARE SUB TCOD_text_set_colors(BYVAL AS TCOD_text_t, BYVAL AS TCOD_color_t, BYVAL AS TCOD_color_t, BYVAL AS SINGLE)
DECLARE FUNCTION TCOD_text_update(BYVAL AS TCOD_text_t, BYVAL AS TCOD_key_t) AS bool
DECLARE SUB TCOD_text_render(BYVAL AS TCOD_text_t, BYVAL AS TCOD_console_t)

DECLARE FUNCTION TCOD_text_get(BYVAL AS TCOD_text_t) AS CONST ZSTRING PTR

DECLARE SUB TCOD_text_reset(BYVAL AS TCOD_text_t)
DECLARE SUB TCOD_text_delete(BYVAL AS TCOD_text_t)

#ENDIF ' _TCOD_TEXT_H_
#ENDIF ' _TCODLIB_H

END EXTERN ' (h_2_bi -P_oCD option)

#IFDEF __FB_WIN32__
#PRAGMA pop(msbitfields)
#ENDIF
#ENDIF ' __TCOD_TJF__

' Translated at 11-09-28 07:16:03, by h_2_bi (version 0.2.1.1,
' released under GPLv3 by Thomas[ dot ]Freiherr{ at }gmx[ dot ]net)

'   Protocol: libtcod.bi
' Parameters:
'                                  Process time [s]: 0.5245289873564616
'                                  Bytes translated: 65344
'                                      Maximum deep: 3
'                                SUB/FUNCTION names: 384
'                                mangled TYPE names: 0
'                                        files done: 25
' libtcod-1.5.1/include/libtcod.h
' libtcod-1.5.1/include/list.h
' libtcod-1.5.1/include/color.h
' libtcod-1.5.1/include/console.h
' libtcod-1.5.1/include/console_types.h
' libtcod-1.5.1/include/image.h
' libtcod-1.5.1/include/sys.h
' libtcod-1.5.1/include/mersenne.h
' libtcod-1.5.1/include/mersenne_types.h
' libtcod-1.5.1/include/mouse.h
' libtcod-1.5.1/include/mouse_types.h
' libtcod-1.5.1/include/bresenham.h
' libtcod-1.5.1/include/noise.h
' libtcod-1.5.1/include/noise_defaults.h
' libtcod-1.5.1/include/fov.h
' libtcod-1.5.1/include/fov_types.h
' libtcod-1.5.1/include/path.h
' libtcod-1.5.1/include/lex.h
' libtcod-1.5.1/include/parser.h
' libtcod-1.5.1/include/tree.h
' libtcod-1.5.1/include/bsp.h
' libtcod-1.5.1/include/heightmap.h
' libtcod-1.5.1/include/zip.h
' libtcod-1.5.1/include/namegen.h
' libtcod-1.5.1/include/txtfield.h
'                                      files missed: 0
'                                       __FOLDERS__: 1
' libtcod-1.5.1/include/
'                                        __MACROS__: 1
' 576: #define TCODLIB_API
'                                       __HEADERS__: 1
' 1: SDL/SDL.h>SDL/SDL.bi
'                                         __TYPES__: 0
'                                     __POST_REPS__: 0
